#define INTERFACE_C

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "color_correct.h"

#include <libgimp/gimp.h>
#include <libgimp/gimpui.h>

#include "ui.h"

#include "data.h"

#define HELP_ID   "plug_in_color_correct"

static void
on_reset_clicked (GtkButton *button,
                  gpointer   user_data);

GtkWidget *
color_correct_dialog (void)
{
	GtkWidget *color_correct = NULL;	/*shut up gcc */
	GtkWidget *notebook;
	GtkTooltips *tooltips;

	tooltips = gtk_tooltips_new ();

	color_correct = gimp_dialog_new (_("Color Correct"), _("colorcorrect"),
                                     NULL, 0,
									 gimp_standard_help_func, HELP_ID,

                                     GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
                                     GTK_STOCK_OK,     GTK_RESPONSE_OK,
                                     NULL);

	g_signal_connect (GTK_OBJECT (color_correct), "destroy",
					  GTK_SIGNAL_FUNC (yuvadjust_close_callback), NULL);

	notebook = gtk_notebook_new ();
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (color_correct)->vbox), notebook,
						TRUE, TRUE, 0);

/*  gtk_notebook_set_tab_hborder (GTK_NOTEBOOK (notebook), 4);
  gtk_notebook_set_tab_vborder (GTK_NOTEBOOK (notebook), 1);
*/

	gtk_notebook_append_page (GTK_NOTEBOOK (notebook),
							  colorbal_ui (),
							  gtk_label_new (_("color balance")));

	gtk_notebook_append_page (GTK_NOTEBOOK (notebook),
							  levels_ui (), gtk_label_new (_("levels")));

	gtk_notebook_append_page (GTK_NOTEBOOK (notebook),
							  automagic_ui (),
							  gtk_label_new (_("automatic")));

/*
	Not implemented yey,.. so just hide the tab

  gtk_notebook_append_page(GTK_NOTEBOOK(notebook),
	  profiles_ui(),
	  gtk_label_new (_("profiles")));
*/

	gtk_widget_show_all (notebook);

	return color_correct;
}

static void
on_reset_clicked (GtkButton *button,
                  gpointer   user_data)
{
	pv.by = 0;
	pv.gy = 128;
	pv.wy = 255;
	pv.bu = pv.gu = pv.wu = pv.bv = pv.gv = pv.wv = 0;
	pv.outb = 0;
	pv.outw = 255;
	pv.saturation = 100;
	update_values ();

	gtk_widget_queue_draw (black_drawingarea);
	gtk_widget_queue_draw (gray_drawingarea);
	gtk_widget_queue_draw (white_drawingarea);
	gtk_widget_queue_draw (levels_drawingarea);
}
