#ifndef COLORCONV_H
#define COLORCONV_H

#ifndef clamp
#define clamp(j,min,max) (j<min?min:j>max?max:j)
#endif

#ifndef fclamp
#define fclamp(j,min,max) do{if(j<min)j=min;if(j>max)j=max;}while(0)
#endif

#ifndef byteclamp
#define byteclamp(j) do{if(j<0)j=0; else if(j>255)j=255;}while(0)
#endif


#define floatRGB2YUV(R,G,B,Y,U,V){\
			Y= ( 0.299*R + 0.587*G + 0.114*B)+000;\
			U= (-0.147*R - 0.289*G + 0.437*B)+128;\
			V= ( 0.615*R - 0.515*G - 0.100*B)+128;\
			byteclamp(Y);\
			byteclamp(U);\
			byteclamp(V);\
}

#define RGB2YUV(R,G,B,Y,U,V){\
			Y= (( 9798*R + 19234*G + 3736*B)>>15)  +000;\
			U= ((-4817*R - 9470*G + 14320*B)>>15)  +128;\
			V= (( 20152*R - 16875*G - 3277*B)>>15) +128;\
			byteclamp(Y);\
			byteclamp(U);\
			byteclamp(V);\
}

#define floatYUV2RGB(Y,U,V,R,G,B){\
			R= (1.000*Y +0.000* (U-128.0) + 1.140*(V-128.0));\
			G= (1.000*Y -0.394* (U-128.0) - 0.581*(V-128.0));\
			B= (1.000*Y +2.028* (U-128.0) + 0.000*(V-128.0));\
			byteclamp(R);\
			byteclamp(G);\
			byteclamp(B);\
}


#define YUV2RGB(Y,U,V,R,G,B){\
			R= ((Y<<15)                 + 37355*(V-128))>>15;\
			G= ((Y<<15) -12911* (U-128) - 19038*(V-128))>>15;\
			B= ((Y<<15) +66454* (U-128)                )>>15;\
			byteclamp(R);\
			byteclamp(G);\
			byteclamp(B);\
}

#define PACK2RGB(PACK,R,G,B){\
			B=(PACK&0xff);\
			col>>=8;\
			G=(PACK&0xff);\
			col>>=8;\
			R=(PACK&0xff);\
}

#define PACKRGB(R,G,B)	(B+ (G<<8)+(R<<16))

#endif
